//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.ApiMairie {

    /** Permet de recuperer l'ensemble des quartiers de la mairie */
    public enum GetApiMairieGetQuartiers {

        public static let service = APIService<Response>(id: "getApiMairieGetQuartiers", tag: "Api Mairie", method: "GET", path: "/apiMairie/getQuartiers", hasBody: false)

        public final class Request: APIRequest<Response> {

            public struct Options {

                public var codeInsee: String

                public init(codeInsee: String) {
                    self.codeInsee = codeInsee
                }
            }

            public var options: Options

            public init(options: Options) {
                self.options = options
                super.init(service: GetApiMairieGetQuartiers.service)
            }

            /// convenience initialiser so an Option doesn't have to be created
            public convenience init(codeInsee: String) {
                let options = Options(codeInsee: codeInsee)
                self.init(options: options)
            }

            public override var parameters: [String: Any] {
                var params: JSONDictionary = [:]
                params["codeInsee"] = options.codeInsee
                return params
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = [Quartier]

            /** Succes */
            case status200([Quartier])

            public var success: [Quartier]? {
                switch self {
                case .status200(let response): return response
                }
            }

            public var response: Any {
                switch self {
                case .status200(let response): return response
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = try .status200(JSONDecoder.decode(data: data))
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
